//BattleMod support

local ScriptLoaded = false
addHook("ThinkFrame", function()
	if not(CBW_Battle) or ScriptLoaded then return end
	ScriptLoaded = true
	local B = CBW_Battle
	
	local WhisperFunction = function(player)
		if player.mo.state == S_PLAY_MELEE then 
			CBW_Battle.SetPriority(player,1,0,"amy_melee",2,3,"hammer strike")
		 end	
		 if player.mo.state == S_PLAY_GLIDE then 
			CBW_Battle.SetPriority(player,0,0,"tails_fly",0,2,nil)
		 end
	end
	
	local WhisperExhaust = function(player)
		if player.whisperfloat or player.secondjump == 1
			if not player.prevhover
				player.exhaustmeter = max(0,$-FRACUNIT/20)
			end
			player.prevhover = true
			local maxtime = 3*TICRATE
			player.exhaustmeter = max(0,$-FRACUNIT/maxtime)
			if player.exhaustmeter <= 0
				player.secondjump = 0
				player.whisperfloat = 0
				player.glidetime = 42
				if player.mo.state == S_PLAY_GLIDE
					player.mo.state = S_PLAY_TWINSPIN
				end
			end
			return true
		else
			player.prevhover = false
		end
	end
	
	B.SkinVars["whisper"] = {
		flags = SKINVARS_GUARD,
		weight = 90,
		guard_frame = 0,
		func_exhaust = WhisperExhaust,
		func_priority_ext = WhisperFunction,
	}
	
	if SKINVARS_NOSPINSHIELD
		B.SkinVars["whisper"].flags = $|SKINVARS_NOSPINSHIELD
	end
end)